﻿variables:
  RELEASE_FOLDER: '/var/www/...'
  PROJECT_PATH: 'src/...'
  SERVICE_NAME: '...' #linux service name
  
stages:  
    - build  
    - deploy   
    
build_job:  
    before_script: 
        - echo $CI_COMMIT_REF_NAME
    stage: build
    tags:
        - ist  #runner tag
    only:
        - master
        - prerelease
    script:      
        - cd $PROJECT_PATH
        - dotnet restore  
        - dotnet publish -c release -o 'bin/deploy_package' /p:DebugType=None
    artifacts:  
        expire_in: 1 week
        paths:
            - $PROJECT_PATH/bin/deploy_package/            
            
deploy_job_dev:  
    stage: deploy
    tags:
        - ist 
    only:   
        - master    
    script:
        - if [[ ! $CI_COMMIT_REF_NAME == "master" ]];then exit;fi
        - cd $PROJECT_PATH        
        - ssh user@dev_ip_address test -f $RELEASE_FOLDER/appsettings.json && rm bin/deploy_package/*.json bin/deploy_package/*.config;
        - rsync -avz -e 'ssh' bin/deploy_package/ user@dev_ip_address:$RELEASE_FOLDER
    dependencies:
        - build_job
    after_script:
        - ssh user@dev_ip_address sudo systemctl restart $SERVICE_NAME       
        - ssh user@dev_ip_address sudo systemctl status $SERVICE_NAME
        
deploy_job_test:
    tags:
        - ist 
    only:   
        - prerelease 
    stage: deploy
    script:
        - if [[ ! $CI_COMMIT_REF_NAME == "prerelease" ]];then exit;fi
        - cd $PROJECT_PATH
        - ssh user@test_ip_address test -f $RELEASE_FOLDER/appsettings.json && rm bin/deploy_package/*.json bin/deploy_package/*.config;
        - rsync -avz -e 'ssh' bin/deploy_package/ user@test_ip_address:$RELEASE_FOLDER
    when: manual
    dependencies:
        - build_job
    after_script:
        - ssh user@test_ip_address sudo systemctl restart $SERVICE_NAME       
        - ssh user@test_ip_address sudo systemctl status $SERVICE_NAME